﻿package {
	
	import flash.events.*;
	import flash.display.*;
	import flash.geom.*;

	public class aGame extends Sprite {
		
		const CHAR_SPRITE_WIDTH = 128 / 4;
		const CHAR_SPRITE_HEIGHT = 192 / 4;
		
		//These correspond to rows in the sprite sheet. Columns will be calc'd on the fly as simply 
		//CHAR_SPRITE_WIDTH * animation sequence position (0, 1, 2, 3)
		const CHAR_SPRITE_DOWN = 0;
		const CHAR_SPRITE_LEFT = 1;
		const CHAR_SPRITE_RIGHT = 2;
		const CHAR_SPRITE_UP = 3;
		var currentSpriteRow:int = 0;
		//Use previousSpriteRow to determine if character has changed direction. If so, animation sequence should be reset.
		//This all happens in the Frame function (main "loop").
		var previousSpriteRow:int = 0; 
		var currentSpriteColumn:int = 0;
		var movingInNewDirection:Boolean = false;
		//This is used to slow down animation. At swf fps's, it'd be running way too fast. The larger this number is, the slower the
		//animation runs. You'll have to adjust it based on how your little fellow[ess]'s animation sheet is set up, and how fast the character
		//is moving..
		const FRAMES_PER_CHAR_STEP = 3; 
		var currentFrameForSteps = 0; //No idea what the heck this variable should be named. It's used in conjunction with FRAMES_PER_CHAR_STEP.
		
		var MOVEMENT_RESOLUTION:int = 3;	
		
		var drawingSurface:Bitmap;
		var drawingSurfaceData:BitmapData;
		var playerSheetBitmapData:CharSheet;
				
		var xPos = 50;
		var yPos = 50;
		
		var ACTION_UP:Boolean = false;
		var ACTION_DOWN:Boolean = false;
		var ACTION_LEFT:Boolean = false;
		var ACTION_RIGHT:Boolean = false;
		
			
		
		public function aGame() {

			drawingSurfaceData = new BitmapData(stage.stageWidth, stage.stageHeight);
			drawingSurfaceData.fillRect(drawingSurfaceData.rect, 0x000000);
			drawingSurface = new Bitmap(drawingSurfaceData);			
			addChild(drawingSurface);
			
			playerSheetBitmapData = new CharSheet(128, 192);
			
			addEventListener(Event.ENTER_FRAME, Frame);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, RegisterAction);
			stage.addEventListener(KeyboardEvent.KEY_UP, UnregisterAction);
		}
		
		public function Frame(evt:Event):void {			
		
			//Process Actions
			if(ACTION_UP) yPos -= 1 * MOVEMENT_RESOLUTION;
			if(ACTION_DOWN) yPos += 1 * MOVEMENT_RESOLUTION;
			if(ACTION_LEFT) xPos -= 1 * MOVEMENT_RESOLUTION;
			if(ACTION_RIGHT) xPos += 1 * MOVEMENT_RESOLUTION;
			
			//------------------------------------------------------------------------------------------
			//Animation Control Logic
			
			//Determine Direction Character is facing. 
			//Note: The order of if's is important if you don't want stupid looking motion (i.e. "sliding
			//during a diagnol walk. I mean, it's gonna look a little stupid anyway with only four perspectives, but I like to think of that
			//as "charm." The other option is to go Zelda 1 style, and don't allow true diagnol motion.
			if(ACTION_UP) { currentSpriteRow = CHAR_SPRITE_UP; }
			if(ACTION_DOWN) { currentSpriteRow = CHAR_SPRITE_DOWN; }
			if(ACTION_LEFT) { currentSpriteRow = CHAR_SPRITE_LEFT; }
			if(ACTION_RIGHT) { currentSpriteRow = CHAR_SPRITE_RIGHT; }
			
			currentFrameForSteps++;
			if(currentFrameForSteps > FRAMES_PER_CHAR_STEP) {
				currentFrameForSteps = 0;
				if(ACTION_UP || ACTION_LEFT || ACTION_RIGHT || ACTION_DOWN) currentSpriteColumn++
			}
			
			//No current action? Set animation position to zero (don't want to stop walking standing on one leg).
			if(!(ACTION_UP || ACTION_LEFT || ACTION_RIGHT || ACTION_DOWN)) currentSpriteColumn = 0;
			
			if(currentSpriteColumn > 3) currentSpriteColumn = 0; //reached end, so reset to beginning of animation sequence.
			if(currentSpriteRow != previousSpriteRow) currentSpriteColumn = 0; //character changed direction, so reset animation sequence.
			previousSpriteRow = currentSpriteRow;
			//~Animation Control Logic
			//------------------------------------------------------------------------------------------
			
			
			//Draw
			drawingSurfaceData.fillRect(new Rectangle(0, 0, stage.width, stage.height), 0);
			drawingSurfaceData.copyPixels(playerSheetBitmapData, 
				new Rectangle(currentSpriteColumn * CHAR_SPRITE_WIDTH, currentSpriteRow * CHAR_SPRITE_HEIGHT, CHAR_SPRITE_WIDTH, CHAR_SPRITE_HEIGHT), 
				new Point(xPos, yPos));			

		}
		
		public function RegisterAction(evt:KeyboardEvent):void {
			
			switch(evt.keyCode) { 
				case 38: //up
					ACTION_UP = true;
				break;
				
				case 40: //down
					ACTION_DOWN = true;
				break;
				
				case 37: //left
					ACTION_LEFT = true;
				break;
				
				case 39: //right
					ACTION_RIGHT = true;
				break;		
			}						
		}
		
		public function UnregisterAction(evt:KeyboardEvent):void {
			switch(evt.keyCode) { 
				case 38: //up
					ACTION_UP = false;
				break;
				
				case 40: //down
					ACTION_DOWN = false;
				break;
				
				case 37: //left
					ACTION_LEFT = false;
				break;
				
				case 39: //right
					ACTION_RIGHT = false;
				break;		
			}								
		}

	}
}